#version 410 core

uniform mat4 ModelViewProjectionMatrix;
uniform mat4 ModelViewMatrix;
uniform float volLength;

layout (location = 0) in vec3 POSITION;
layout (location = 1) in vec3 NORMAL;
layout (location = 4) in vec2 TEXCOORD;

out vec3 wpos;
out vec3 uv_shade;

void main()
{
	wpos = vec3(ModelViewMatrix * vec4(POSITION, 1.0));
	uv_shade.xy = TEXCOORD;
	uv_shade.z = 1.0 - (POSITION.z / volLength);

	gl_Position = ModelViewProjectionMatrix * vec4(POSITION, 1.0);
}
